datablock AudioProfile(NapalmStageASound)
{
	filename = "./NapalmExploStgA.wav";
	preload = true;
	description = AudioDefault3d;
};

datablock ParticleData(NapalmBombDebrisTrailParticle)
{
	TextureName = "base/data/particles/dot.png";
	times[0] = 0.0;
	times[1] = 0.7;
	times[2] = 0.9;
	times[3] = 1.0;
	colors[0] = "0.75 0.75 0.0 1.0";
	colors[1] = "0.0 0.0 0.0 0.95";
	colors[2] = "0.3 0.3 0.3 0.4";
	colors[3] = "0.35 0.35 0.35 0.0";
	lifetimeMS = 1000;
	sizes[0] = 0.8;
	sizes[1] = 0.7;
	sizes[2] = 0.5;
	sizes[3] = 0.0;
	useInvAlpha = false;
};

datablock ParticleData(NapalmBombParticles)
{
	TextureName = "base/data/particles/cloud.png";
	times[0] = 0.0;
	times[1] = 0.8;
	times[2] = 1.0;
	colors[0] = "1.0 0.501 0.05 1.0";
	colors[1] ="1.0 0.501 0.05 0.6"; //1.0 0.501 0.05
	colors[2] ="1 0.7 0.05 0.5";
	sizes[0] = 20.0;
	sizes[1] = 15;
	sizes[2] = 0.0;
	lifetimeMS = 250;
	useInvAlpha = true;
	spinRandomMax = 0;
	spinRandomMin = 0;
	spinSpeed = 0.0;
	inheritedVelFactor = 1;
};

datablock ParticleEmitterData(NapalmBombEmitter)
{
	ejectionPeriodMS = 50;
	orientParticles = false;  //hmm this makes it look undesireable?
	particles = "NapalmBombParticles";
	phiReferenceVel = 0;
	phiVariance = 90.0;
	sortParticles = false; //hmm this could also look odd
	thetaMin = 0;
	thetaMax = 360;
	lifetimeMS = 12000; // same as projectile
	ejectionVelocity = 0;
};

datablock ParticleEmitterData(NapalmBombDebrisTrailEmitter)
{
	ejectionPeriodMS = 10;
	lifetimeMS = 10000;
	particles = NapalmBombDebrisTrailParticle;
	dragCoefficient		= 3.0;
	gravityCoefficient	= 0.01;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	
};

datablock DebrisData(NapalmBombCarrierDebris)
{
	shapeFile = "./empty.dts";
	fade = true;
	ignoreWater = false;
	baseRadius = 0.75;
	bounceVariance = 2;
	elasticity = 0.4;
	friction = 0.2;
	gravModifier = 3;
	lifetime = 10000;
	lifetimeVariance = 0;
	numBounces = 3;
	terminalVelocity = 20;
	velocity = 15;
	velocityVariance = 10;
	emitters[0] = NapalmBombDebrisTrailEmitter;

};

datablock ExplosionData(NapalmBombCarrierExplosion)
{
	Debris = NapalmBombCarrierDebris;
	debrisNum = 5;
	debrisNumVariance = 1;
	debrisPhiMax = 160;
	debrisPhiMin = -160;
	debrisThetaMax = 360;
	debrisThetaMin = 0;
	lifetimeMS = 100;
	lightStartRadius = 1;
	lightStartColor = "1.0 1.0 0 1"; 	
	lightEndRadius = 5;
	lightEndColor = "1.0 0.3 0 1";
	sizes[0] = 1;
	sizes[1] = 10;
	soundProfile = NapalmStageASound;
};

datablock ExplosionData(NapalmBombExplosion)
{
	lifetimeMS = 500;
	emitter[0] = NapalmBombEmitter;
	damageRadius = 2000;
    radiusDamage = 20;
	
	lightStartRadius = 10;
	lightStartColor = "1.0 0.596 0.164 1.0";
	lightStartBrightness  = 2;
	lightEndRadius = 10;
	lightEndColor = "1.0 0.596 0.164 1.0";
	lightEndBrightness  = 2;

};



datablock ProjectileData(NapalmBombCarrier)
{
	explodeOnDeath = 1;
	isBallistic = true;
	armingDelay         = 2500; 
   lifetime            = 2500;
   fadeDelay           = 3000;
	projectileShapeName = "./B2Missile.dts";
	Explosion = NapalmBombCarrierExplosion;
	
	// spawn vars

};

datablock ProjectileData(NapalmFalling)
{
	explodeOnDeath = 0;
	lifetime = 12000;
	armingDelay = 12000;
	gravMod = 2;
	isBallistic = true;
	ParticleEmitter = NapalmBombEmitter;
	projectileShapeName = "./empty.dts";
	hasLight = false;
};

datablock ProjectileData(NapalmPart : NapalmFalling)
{
	directDamage = 1;
	directDamageType = $DamageType::Direct;
	radiusDamageType = $DamageType::Radius;
	ParticleEmitter = "";
	bounceElasticity = 0.0;
	explodeOnDeath = 1;
	armingDelay = 12000;
	explosion = NapalmBombExplosion;
	hasLight = true;
	lightDesc = napalmFireLight;
	radius = 10;
	damage = 2;
};

function NapalmFalling::onCollision(%this, %proj, %fade, %pos, %norm)
{
	%proj.setDataBlock(NapalmPart);
	%proj.onAdd(%proj);
	Parent::onCollision(%this, %proj, %fade, %pos, %norm);
}

package NapalmBombPackage
{
	function projectile::onAdd(%obj)
	{
		Parent::onAdd(%obj);
		if(%obj.dataBlock $= "NapalmPart")
		{
			%obj.nextSplode = schedule(500,0,"flamer",%obj);
		}
	}
	
	function projectile::onRemove(%obj)
	{
		cancel(%obj.nextSplode);
	}

	function flamer(%obj)
	{
		%center = %obj.getPosition();
		%explode = new explosion()
		{
			dataBlock = NapalmBombExplosion;
			position = %center;
		}; MissionCleanup.add(%explode);
		
		
		// find and damage everything within the explosion
		// not by the explosion already for some reason :/
		
	
		initContainerRadiusSearch(%center,%obj.dataBlock.radius,$TypeMasks::PlayerObjectType);
		
		while(%player = ContainerSearchNext())
		{
			if(%player.getControllingClient().minigame > 0)
				%player.addHealth(-1 * %obj.dataBlock.damage);
		}
			initContainerRadiusSearch(%center,%obj.dataBlock.radius,$TypeMasks::VehicleObjectType);
		while(%vehicle = ContainerSearchNext())
		{
			%vehicle.applyDamage(%obj.dataBlock.damage);
		}
		
		%obj.nextSplode = schedule(500,0,"flamer",%obj);
	}
// /* 
	// function damageAll(%center,%radius,%damage)
// {
    // initContainerSearch(%center,%radius,$TypeMasks::PlayerObjectType);
    // while(%player = ContainerSearchNext())
    // {
        // %player.addHealth(-1 * %damage);
    // }
    // initContainerSearch(%center,%radius,$TypeMasks::VehicleObjectType);
    // while(%vehicle = ContainerSearchNext())
    // {
        // %vehicle.addHealth(-1 * %damage);
        // //or however the hell you damage vehicles
    // }
// } */

	function NapalmBombCarrier::onExplode(%this, %projectile)
	{
		%max = 10;
		%min = 7;
		%maxTheta = 360;
		%minTheta = 0;
		%maxPhi = 45;
		%minPhi = 10;
		%initSpeed = 5;
		%speedVarience = 2;
		%pos = %projectile.getPosition();
		
		
		
		//a bit of error checking in case some not-so-experienced scripters look at this
		// or I mess it up
		if(%maxTheta > 360)
			%maxTheta = 360;
		if(%minTheta < 0)
			%minTheta = 0;
		if(%minTheta > %maxTheta)
			%minTheta = %maxTheta;
		
		if(%minPhi < -90)
			%minPhi = -90;
		if(%maxPhi > 90)
			%minPhi = 90;
		if(%minPhi > %maxPhi)
			%minPhi = %maxPhi;
		
		%bomb = NapalmFalling;
		
		%numNew = getRandom(%min, %max);
		for(%i = 0; %i < %numNew; %i++)
		{
			if(%initSpeed >= %speedVarience)
			{
				%speed = getRandom(%initSpeed - %speedVarience,%speedVarience + %initSpeed);
				//warn(%projectile.dataBlock.name @ " speedVarience > initSpeed!!!");
			}
			else
				%speed = getRandom(0.0,%speedVarience + %initSpeed);
				
			
			%x = mCos(mDegToRad(getRandom(%minTheta, %maxTheta)));
			%y = mSin(mDegToRad(getRandom(%minTheta, %maxTheta)));
			%z = mSqrt(mPow(mSin(mDegToRad(getRandom(%minTheta, %maxTheta))),2) + mPow((%x*%y),2));
				
			%newSpeed = %x @ " " @ %y @ " " @ %z;

			
			%newSpeed = VectorScale(%newSpeed, %speed);
			
			%obj = new projectile()
			{
				dataBlock = %bomb;
				initialPosition = %pos;
				initialVelocity = %newSpeed;
				sourceObject = %projectile;
				client = %obj.client;
				
			}; MissionCleanup.add(%obj);
			
		}
		Parent::onExplode(%this, %projectile);
	}
};
 activatePackage(NapalmBombPackage);