datablock ParticleData(SpiritJetSmokeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.02;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.4 0.4 0.4 0.2";
	colors[1]     = "0.6 0.6 0.6 0.0";
	sizes[0]      = 0.7;
	sizes[1]      = 7;

	useInvAlpha = true;
};

datablock ParticleEmitterData(SpiritJetSmokeEmitter)
{
	ejectionPeriodMS = 5;
	ejectionVelocity = 0.01;
	ejectionVelocityVariance = 0.0;
	thetaMin     = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
    particles = SpiritJetSmokeParticle;
};

datablock ShapeBaseImageData(SpiritJetSmokeImage)
{
	shapeFile = "./empty.dts";
	mountPoint = 1;
	emap = false;
	rotation = "1 0 0 180";
	
	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1] = "FireA";
		stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= SpiritJetSmokeEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

datablock ShapeBaseImageData(SpiritJetSmokeImage2)
{
	shapeFile = "./empty.dts";
	mountPoint = 2;
	emap = false;
	rotation = "1 0 0 180";
	
	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1] = "FireA";
		stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= SpiritJetSmokeEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

package B2BomberPackage
{
	function SpiritJetSmokeImage::onDone(%this,%obj,%slot)
	{
		%obj.unMountImage(%slot);
	}

	function JetEngineCheck(%obj)
	{
		//we do not want to crash, right?
		if(!isObject(%obj))
			return;
		
		%speed = vectorLen(%obj.getVelocity());
		
		if(%speed >= 40)
		{
		
			if(%obj.getMountedImage(0) $= 0)
			{
				%obj.mountImage(SpiritJetSmokeImage,0);
			}
			if(%obj.getMountedImage(1) $= 0)
			{
				%obj.mountImage(SpiritJetSmokeImage2,1);
			}
		}
		else
		{
			if(%obj.getMountedImage(1) !$= "")
				%obj.unMountImage(1);
			if(%obj.getMountedImage(0) !$= "")
				%obj.unMountImage(0);
		}
		schedule(2000,0,"JetEngineCheck",%obj);
	}
};
 activatePackage(B2BomberPackage);