datablock AudioProfile(spiritEngineLoop)
{
	filename = "./engineLoop.wav";
	preload = true;
	description = AudioDefaultLooping3D;
};

datablock AudioProfile(gearSFX)
{
	filename = "./gear.wav";
	preload = false;
	description = AudioDefault3d;
};


datablock WheeledVehicleData(SpiritVehicle)
{

	category = "Vehicles";
	displayName = " ";
	emap = true;
	shapeFile = "./B2.dts";
	minMountDist = 3;
	integration = 4;  
	//mounts
	numMountPoints = 1;
	mountThread[0] = "sit";
	justcollided = 0;
	
	minTrailSpeed        = 1;
	
	numDmgEmitterAreas   = 0;
	
	
	//tires
	defaultTire	= spiritTire;
	defaultSpring	= spiritSpring;
	
	numWheels = 3;
	
	//tireEmitter = VehicleTireEmitter;
	
	engineTorque = 400; //4000;       // Engine power
	engineBrake = 1000;         // Braking when throttle is 0
	brakeTorque = 7000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed
	
	massCenter = "0 0 0";
	
	// Advanced Steering
   steeringAutoReturn = false;
   //steeringAutoReturnRate = 0.9;
   //steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   //steeringStrafeSteeringRate = 0.1;
	
	
	forwardThrust		= 1500;
	reverseThrust		= 1000;
	lift			= 60;
	maxForwardVel		= 50;
	maxReverseVel		= 20;
	horizontalSurfaceForce	= 55;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 55; 
	rollForce		= 20000;
	yawForce		= 8000;
	pitchForce		= 5000;
	rotationalDrag		= 0.5;
	stallSpeed		= 20;
	
	
	//softImpactSound = slowImpactSound;
	//hardImpactSound = fastImpactSound;
	
	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
	
		// Energy
	maxEnergy = 100;
	jetForce = 3000000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;
	
	steeringForce = 10;
	bodyRestitiution = 0;
	CameraRoll = false;
	maxSteeringAngle =0.75;
	cameraMaxDist = 30;
	cameraOffset = 10;
	cameraLag = 0.5;
	cameraDecay = 0.75;
	cameraTilt = 0.4;
	collisionTol = 0.4;
	contactTol = 0.1;
	mass = 70;
	density = 1.01;
	drag = 2.5;
	uiName = "B2- spirit";
	rideable = true;
	lookUpLimit  = 0.5;
	lookDownLimit = 0.5;
	paintable = true;
	isSled = false;
	maxDamage = 140.00;
    destroyedLevel = 140.00;
    energyPerDamagePoint = 160;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier   = 0.02;
	
	
	//ShootOnClick
	shootonclick=1;
	shootonclick_RequiredSlot=0;
	shootOnClick_ProjectileCount = 1;
	ShootOnClick_Position[0] = "0 0 -3";
	ShootOnClick_Velocity[0] = "0 0 -2";
	ShootOnClick_Scale[0] = "1 1 1";
	ShootOnClick_Projectile[0] =  NapalmBombCarrier;
	ShootOnClick_Sound = "";
	ShootOnClick_Hold = true;
	ShootOnClick_ReshootDelay = 5000;
	ShootOnClick_ShootDelay = 5000;
	
	//custom junk
	minSmokeSpeed = 15;
};

function SpiritVehicle::onadd(%this,%obj)
{
	Parent::onAdd(%this, %obj);
	%obj.PlayAudio(0,spiritEngineLoop);
	JetEngineCheck(%obj);
	
	//custom vars
	%this.gearDown = true;
}

package SpiritBomberPackage
{
	function serverCmdLight(%this)
	{
		if(%this.player.isMounted() && %this.player.getObjectMount().dataBlock $= "SpiritVehicle")
		{
			//get the vehicle we are mounted to (spiritBomber)
			%veh = %this.player.getObjectMount();
			
			//play correct animation
			if(!%veh.gearDown)
			{
				%veh.playThread(0,"RaiseGear");
				%veh.playAudio(1,gearSFX);
				for(%i = 0; %i < %veh.dataBlock.numWheels; %i++)
					%veh.setWheelTire(%i,invisaSpiritTire);
			}
			else
			{
				%veh.playThread(0,"LowerGear");
				%veh.playAudio(1,gearSFX);
				for(%i = 0; %i < %veh.dataBlock.numWheels; %i++)
					%veh.schedule( 2000,setWheelTire,%i,spiritTire);

			}
			//toggle state
			%veh.gearDown = !%veh.gearDown;
		}
		else
		{
			Parent::serverCmdLight(%this);
		}
	}
};
activatePackage(SpiritBomberPackage);